<script lang="ts">
  import {
    startTouch,
    moveTouch,
    swipeIsRefreshing
  } from "$lib/tidy/utils/touchGesture";
  import view from "$lib/tidy/stores/view.store";
  import { page } from "$app/stores";
  import NestedGoalAccordion from "../components/goals/NestedGoalAccordion.svelte";
  import Autocomplete from "$lib/tidy/elements/autocomplete/Autocomplete.svelte";
  import TagsContainer from "../components/goals/TagsContainer.svelte";
  import { TagId } from "../types/tagId.enum";
  import Icon from "$lib/tidy/elements/Icon.svelte";
  import { Size } from "$lib/tidy/types/size.enum";
  import { tagStore } from "../stores/local.store";
  import { PointronEventEnum } from "../types/pointronEvent.enum";
  import { retrieveCurrentColors } from "$lib/tidy/utils/theme.utils";
  import { ButtonVariant } from "$lib/tidy/types/button.type";
  import Panel from "$lib/tidy/layout/paint/Panel.svelte";
  import EmptyStatusView from "$lib/tidy/elements/feedback/EmptyStatusView.svelte";
  import { runAction } from "$lib/tidy/utils/utils";
  import { goalStore } from "../stores/goal.store";
  import { isValidArrayWithData } from "$lib/tidy/utils/obj.utils";
  import RefreshingOverlayFeedback from "$lib/tidy/elements/feedback/RefreshingOverlayFeedback.svelte";
  import appearance from "$lib/tidy/stores/appearance.store";
  import { onMount } from "svelte";
  import { dataManager } from "$lib/tidy/stores/data.store";
  import { Item } from "$lib/tidy/types/item.enum";
  import { TextStyle } from "$lib/tidy/types/text.enum";
  import PageLayer from "$lib/tidy/layout/layers/PageLayer.svelte";
  import TreeMapItem from "$lib/tidy/components/treeMap/TreeMapItem.svelte";
  import TreeMap from "$lib/tidy/components/treeMap/TreeMap.svelte";
  import ScrollViewBottomSpacer from "$lib/tidy/elements/ScrollViewBottomSpacer.svelte";

  export let isGoalsHome = window.location.pathname === "/goals";
  export let parentBackgroundIndex: number = 0;

  let color = retrieveCurrentColors($appearance).aps1;
  let selectedGoalId: string = "";
  let selectedTagId: TagId | string = TagId.ALL;
  $: isGoalsHome =
    $page?.url.pathname === "/goals" || $page?.url.pathname === "/goals/";
  $: selectedTagName =
    selectedTagId &&
    selectedTagId != TagId.ALL &&
    selectedTagId != TagId.FAVORITES
      ? $tagStore.tags.find((x) => x.id === selectedTagId)?.label
      : "";

  let isArchivedGoalsVisible: boolean = false;
  let searchInput: string = "";
  let isGoalsLoading: boolean = false;

  async function handleAccordionStateChange({ detail }: CustomEvent) {
    console.log("handleAccordianstatechagne", { detail });
    const { id } = detail;
    goalStore.resolveSubGoalsIfNotPresent(id);
  }

  function refresh() {
    dataManager.refreshPage([Item.PointGoal, Item.PointTag]);
  }
  function filter() {
    goalStore.filter({
      tag: selectedTagId,
      searchText: searchInput
    });
  }
  onMount(async () => {
    refresh();
  });
  function onGoalClick(event: CustomEvent<string>) {
    selectedGoalId = event.detail;
    view.gotoPath(`/goals/${selectedGoalId}`);
  }
</script>

{#if $view.isPortrait && !isGoalsHome}
  <div class="flex flex-col h-full">
    <!-- <button
      class="flex max-w-min bg-bgs2 px-2"
      on:click={() => {
        windowObject.gotoPath("/goals");
      }}
    >
      <Icon icon="chevron-left" />
      <span class="text-b3">back</span>
    </button> -->
    <button
      class="flex mt-4 gap-1 items-center min-w-fit p-4 h-2 text-aps1"
      style="top: 1.75rem;"
      on:click={() => {
        view.gotoPath("/goals");
      }}
    >
      <Icon icon="chevleft" size={Size.sm} {color} />
      <div class="pr-1">Back</div>
    </button>
    <slot />
  </div>
{:else if isGoalsHome || !$view.isPortrait}
  <div
    id="GoalsLayoutOuter"
    on:touchstart={startTouch}
    on:touchmove={() =>
      moveTouch(event, undefined, undefined, refresh, undefined, undefined)}
    class="flex w-full h-full select-none relative"
  >
    <Panel
      title="Goals"
      floatingButton={{
        label: "Create new goal",
        callback: async () => runAction(PointronEventEnum.CREATE_EDIT_GOAL),
        icon: "plus",
        variant: ButtonVariant.PRIMARY
      }}
    >
      <slot name="nonpadded" slot="nonpadded">
        <div class="flex flex-col gap-4 px-4 pb-2 items-start">
          <Autocomplete
            inputClassList="rounded-full"
            bind:inputValue={searchInput}
            on:search={filter}
            placeholder="search goals"
            hideResetIcon
          />
          <TagsContainer
            bind:selectedTagId
            on:select={filter}
            isShowAddTag={true}
          />
        </div>
        <div
          id="GoalsLayoutInner"
          on:touchstart|stopPropagation={startTouch}
          class="relative flex flex-col h-full gap-8 flex-grow pt-4"
        >
          <!-- TODO - swipeIsRefreshing - attach to goalStore.isRefreshin - on swipe refresh -->
          {#if $goalStore.isRefreshing}
            <RefreshingOverlayFeedback />
          {/if}
          <div class="h-full w-full">
            {#if isValidArrayWithData($goalStore.filteredGoals)}
              <!-- {#each $goalStore.filteredGoals as goal (goal.id)}
                <NestedGoalAccordion
                  id={goal.id}
                  label={goal.label}
                  subGoalCount={goal.subGoalCount}
                  subGoals={goal.subGoals}
                  color={goal.color}
                  isArchived={goal.isArchived}
                  parent={goal.parent?.hierarchy}
                  on:state-change={handleAccordionStateChange}
                />
                <div class="line-bottom bg-bgs2 w-full h-[1px]" />
              {/each} -->
              <div class="w-full grow">
                <TreeMap
                  items={$goalStore.filteredGoals.map((x) => x.id)}
                  contentCallback={goalStore.get}
                  childrenCallback={goalStore.children}
                  on:click={onGoalClick}
                />
              </div>
              {#if $goalStore.archivedGoals.length > 0 && !isGoalsLoading && !searchInput && selectedTagId === TagId.ALL}
                <div
                  class="acrchived-goals flex flex-col items-center mt-[6rem]"
                >
                  <!-- svelte-ignore a11y-no-noninteractive-tabindex -->
                  <div
                    tabindex="0"
                    on:keydown={() => {}}
                    on:click={() => {
                      isArchivedGoalsVisible = !isArchivedGoalsVisible;
                    }}
                    class="cursor-pointer flex items-center gap-2 py-3"
                  >
                    <Icon
                      size={Size.sm}
                      icon={isArchivedGoalsVisible ? "chevdown" : "chevup"}
                    />
                    <h3 class="text-fgs3 uppercase text-b2">
                      Archived goals ( {$goalStore.archivedGoals.length} )
                    </h3>
                    <!-- <div
                      class={`inverted-triangle-path w-2.5 h-2 bg-fgs3 ${
                        isArchivedGoalsVisible ? `rotate-[180deg]` : ``
                      }`}
                    /> -->
                  </div>
                  {#if isArchivedGoalsVisible}
                    {#each $goalStore.archivedGoals as goal}
                      <NestedGoalAccordion
                        id={goal.id}
                        label={goal.label}
                        subGoalCount={goal.subGoalCount}
                        subGoals={goal.subGoals}
                        color={goal.color}
                        isArchived={goal.isArchived}
                        on:state-change={handleAccordionStateChange}
                      />
                      <div class="line-bottom bg-bgs2 w-full h-[1px]" />
                    {/each}
                    <div class="pb-32"></div>
                  {/if}
                </div>
              {/if}
              <ScrollViewBottomSpacer />
            {:else}
              <EmptyStatusView
                size={Size.sm}
                isLoadingState={isGoalsLoading}
                mainText="No goals found"
              >
                <slot name="subtext" slot="subtext">
                  {#if selectedTagId === TagId.FAVORITES}
                    Please favorite a goal to see them here.
                  {:else if !selectedTagId || selectedTagId === TagId.ALL}
                    Please create a new goal using the button below.
                  {:else}
                    Please add the tag <b>#{selectedTagName ?? ""}</b> to a goal
                    to see them here
                  {/if}
                </slot>
              </EmptyStatusView>
            {/if}
          </div>
        </div>
      </slot>
      <slot name="right" slot="right">
        <slot />
      </slot>
    </Panel>
  </div>
  <style>
    .inverted-triangle-path {
      clip-path: polygon(0% 0%, 50% 100%, 100% 0%);
    }
  </style>
{/if}
<PageLayer on:appear={refresh} />

<style>
  .animate-spin {
    display: block;
    position: absolute;
    top: 4%;
    left: 48%;
  }
</style>
